10 ' use screen coordinates 1-640 in x, 1-398 in y
20 ' program to plot field lines for a set of point charges.
30 '
35 DIM XC(20), YC(20), QC(20), XSLOT(200), YSLOT (200), AC(20)
36 DIM ASLOT(20,200)
38 TT = AMIN(5, S/1.4)
40  PI = 3.141593
41 PRINT" When plot is finished press any key to continue."
42 FOR JJ = 1 TO 20
43   XC(JJ) = 0:  YC(JJ) = 0:  QC(JJ) = 0 :  AC(JJ) = 0
45 FOR J = 1 TO 200
47    XSLOT(J) = 0: YSLOT(J) = 0 : ASLOT(JJ,J) = 0
48 NEXT J
49 NEXT JJ
50 INPUT "How many charges? (1 <= N <= 20)"; N
55 IF (N < 21) GOTO 58
56 PRINT "You have specified too many charges"
57 GOTO 50
58 IF N > 0 GOTO 60
59 PRINT"Error in charge number.  Try again": GOTO 50
60 I = 0
65 PRINT "Charges have x-coordinate between 1 and 640 and"
66 PRINT "y-coordinate between 1 and 398.  Use commas between numbers."
70  INPUT " give x, y coordinates and magnitude of next charge" ; X,Y,Q
75 IF Q <> 0 GOTO 80
76 PRINT"You entered a charge of zero: Try again.": GOTO 70
80  I = I+1
81 FOR J = 1 TO I
82  IF X = XC(J) AND Y = YC(J) GOTO 86
83 NEXT J
84 GOTO 90
86 PRINT"You have put two charges at the same place. Try again"
87 GOTO 42
90  XC(I) = X : YC(I) = Y : QC(I) = Q
100 IF I < N GOTO 70
110 INPUT " specify step size: 6 = 1% of screen width" ; S
115 IF S < .5 GOTO 110
120 INPUT " number of lines per charge to draw"; NL
130 INPUT "starting angle, pi/N. Give N. " ;NA
140 ND = 0
150 NC = 1
155 NSLOT = 0
160 SCREEN 2,0,0,0: CLS: KEY OFF
170 'mark the charges
180 FOR J = 1 TO N
190    XP = XC(J)
200    YP = YC(J)
210    CIRCLE (XP,YP/2),5 : PSET (XP,YP/2)
220 NEXT J
230 ANG1 = 3.141593/NA
240 K = NC :  IF K > N THEN GOTO 500
242   ANG2 = ANG1
245   NLK = NL*ABS(QC(K))
247   IF (NLK < 200) GOTO 250
248   PRINT "you have specified too many lines."
249   GOTO 120
250   ANGO = 2*PI/NLK
255 ' Begin calculating lines for charge # K
257   ND = ND + 1
264   IF ND =< NLK THEN GOTO 281
265 ' Completed all lines for this charge
270       ND = 0: NC = NC + 1 : GOTO 240
272 IF NC = 1 THEN GOTO 281
274  IF (AC(K) <> 0) THEN ANG2 = AC(K)
281   ANG = ANGO*ND+ANG2: X = XC(K): Y = YC(K)
282 IF ANG > 2*PI THEN ANG = ANG - 2*PI
286   X = X + S*COS(ANG): Y = Y+S*SIN(ANG)
287   IF NSLOT = 0 THEN GOTO 295
288   FOR L = 1 TO 200
289  IF ABS(ANG - ASLOT(K,L)) < ANGO/2 THEN GOTO 257
290  IF ABS(ANG - ASLOT(K,L)-2*PI) < ANGO/2 THEN GOTO 257
294   NEXT L
295 ST = S
300 IF QC(K) < 0 THEN ST = -S
305 INDEX = 0
307 ' Compute E
310 EX = 0 : EY = 0
320 FOR J = 1 TO N
330   RSQ = (X-XC(J))^2+(Y-YC(J))^2
332 ' Check that point is not too near any charge
334   IF RSQ > S*S THEN GOTO 350
335 ' Starting too close.  Step away a bit.
336   IF INDEX = 0 THEN GOTO 286
337 ' Got too close.  End this line
339     NSLOT = NSLOT + 1
340     ARG = (Y-YC(J))/(X-XC(J))
341     ANGD = ATN(ARG)
343     IF (X-XC(J)) < 0  THEN ANGD = ANGD + PI
344     AC(K) = ANGD
345   IF NSLOT > 200 THEN END
348     XSLOT(NSLOT) = X: YSLOT(NSLOT) = Y : ASLOT(J,NSLOT) = ANGD
349     GOTO 257
350   RTH = RSQ^1.5
360   EX = EX + QC(J)*(X-XC(J))/RTH
370   EY = EY + QC(J)*(Y-YC(J))/RTH
380 NEXT J
390 ESQ = EX^2 + EY^2: E = SQR(ESQ)
400 IF E < .000001*S THEN GOTO 257
405 INDEX = 1: STEPX = ST*EX/E : STEPY = ST*EY/E
406 ' Check that line is not "stalled"
407 IF (ABS(STEPX)> S/20 OR ABS(STEPY)> S/20) GOTO 410
408 PRINT "line stalled at charge #"; NC, ND,STEPX,STEPY : GOTO 257
409 ' Step along field line
410 X2 = X + STEPX : Y2 = Y + STEPY
418 ' Check that line has not gone off screen
420   IF (X2 > 630) OR (X2 < 1) GOTO 257
430   IF Y2 > 398 OR Y2 < 1 GOTO 257
440  LINE (X,Y/2)-(X2,Y2/2)
450 X = X2: Y = Y2 : GOTO 310
500 L$ = INKEY$: IF L$ = "" THEN 500
510 SCREEN 0,0,0,0
511 INPUT "Do you wish to end this session? Y or N?";ZQ$
512 IF (ZQ$ = "Y") OR (ZQ$ = "y") GOTO 520
513 GOTO 42
520 END
